﻿
namespace RIAServicesWithPoco.Web.Services
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using RIAServicesWithPoco.Web.Models;


    // Implements application logic using the ChinookEntities context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public partial class ChinookDomainService : LinqToEntitiesDomainService<ChinookEntities>
    {

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Albums' query.
        public IQueryable<Album> GetAlbums()
        {
            return this.ObjectContext.Albums
                       .Include("Artist")
                       .OrderBy(i => i.Artist.Name)
                       .ThenBy(i => i.Title);
        }

        public void InsertAlbum(Album album)
        {
            if ((album.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(album, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Albums.AddObject(album);
            }
        }

        public void UpdateAlbum(Album currentAlbum)
        {
            this.ObjectContext.Albums.AttachAsModified(currentAlbum, this.ChangeSet.GetOriginal(currentAlbum));
        }

        public void DeleteAlbum(Album album)
        {
            if ((album.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Albums.Attach(album);
            }
            this.ObjectContext.Albums.DeleteObject(album);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Artists' query.
        public IQueryable<Artist> GetArtists()
        {
            return this.ObjectContext.Artists;
        }

        public void InsertArtist(Artist artist)
        {
            if ((artist.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(artist, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Artists.AddObject(artist);
            }
        }

        public void UpdateArtist(Artist currentArtist)
        {
            this.ObjectContext.Artists.AttachAsModified(currentArtist, this.ChangeSet.GetOriginal(currentArtist));
        }

        public void DeleteArtist(Artist artist)
        {
            if ((artist.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Artists.Attach(artist);
            }
            this.ObjectContext.Artists.DeleteObject(artist);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Customers' query.
        public IQueryable<Customer> GetCustomers()
        {
            return this.ObjectContext.Customers;
        }

        public void InsertCustomer(Customer customer)
        {
            if ((customer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(customer, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Customers.AddObject(customer);
            }
        }

        public void UpdateCustomer(Customer currentCustomer)
        {
            this.ObjectContext.Customers.AttachAsModified(currentCustomer, this.ChangeSet.GetOriginal(currentCustomer));
        }

        public void DeleteCustomer(Customer customer)
        {
            if ((customer.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Customers.Attach(customer);
            }
            this.ObjectContext.Customers.DeleteObject(customer);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Employees' query.
        public IQueryable<Employee> GetEmployees()
        {
            return this.ObjectContext.Employees;
        }

        public void InsertEmployee(Employee employee)
        {
            if ((employee.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(employee, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Employees.AddObject(employee);
            }
        }

        public void UpdateEmployee(Employee currentEmployee)
        {
            this.ObjectContext.Employees.AttachAsModified(currentEmployee, this.ChangeSet.GetOriginal(currentEmployee));
        }

        public void DeleteEmployee(Employee employee)
        {
            if ((employee.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Employees.Attach(employee);
            }
            this.ObjectContext.Employees.DeleteObject(employee);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Genres' query.
        public IQueryable<Genre> GetGenres()
        {
            return this.ObjectContext.Genres;
        }

        public void InsertGenre(Genre genre)
        {
            if ((genre.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(genre, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Genres.AddObject(genre);
            }
        }

        public void UpdateGenre(Genre currentGenre)
        {
            this.ObjectContext.Genres.AttachAsModified(currentGenre, this.ChangeSet.GetOriginal(currentGenre));
        }

        public void DeleteGenre(Genre genre)
        {
            if ((genre.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Genres.Attach(genre);
            }
            this.ObjectContext.Genres.DeleteObject(genre);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Invoices' query.
        public IQueryable<Invoice> GetInvoices()
        {
            return this.ObjectContext.Invoices;
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'InvoiceLines' query.
        public IQueryable<InvoiceLine> GetInvoiceLines()
        {
            return this.ObjectContext.InvoiceLines;
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MediaTypes' query.
        public IQueryable<MediaType> GetMediaTypes()
        {
            return this.ObjectContext.MediaTypes;
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Playlists' query.
        public IQueryable<Playlist> GetPlaylists()
        {
            return this.ObjectContext.Playlists;
        }

        public void InsertPlaylist(Playlist playlist)
        {
            if ((playlist.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(playlist, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Playlists.AddObject(playlist);
            }
        }

        public void UpdatePlaylist(Playlist currentPlaylist)
        {
            this.ObjectContext.Playlists.AttachAsModified(currentPlaylist, this.ChangeSet.GetOriginal(currentPlaylist));
        }

        public void DeletePlaylist(Playlist playlist)
        {
            if ((playlist.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Playlists.Attach(playlist);
            }
            this.ObjectContext.Playlists.DeleteObject(playlist);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Tracks' query.
        public IQueryable<Track> GetTracks()
        {
            return this.ObjectContext.Tracks;
        }

        public void InsertTrack(Track track)
        {
            if ((track.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(track, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Tracks.AddObject(track);
            }
        }

        public void UpdateTrack(Track currentTrack)
        {
            this.ObjectContext.Tracks.AttachAsModified(currentTrack, this.ChangeSet.GetOriginal(currentTrack));
        }

        public void DeleteTrack(Track track)
        {
            if ((track.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Tracks.Attach(track);
            }
            this.ObjectContext.Tracks.DeleteObject(track);
        }
    }
}


