﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Data.Objects.DataClasses;
using System.ServiceModel.DomainServices.Server;

namespace RIAServicesWithPoco.Web.Models
{
    // The MetadataTypeAttribute identifies AlbumMetadata as the class
    // that carries additional metadata for the Album class.
    [MetadataTypeAttribute(typeof(Album.AlbumMetadata))]
    public partial class Album
    {

        // This class allows you to attach custom attributes to properties
        // of the Album class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class AlbumMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private AlbumMetadata()
            {
            }

            public int AlbumId { get; set; }

            [Include]
            public Artist Artist { get; set; }

            public int ArtistId { get; set; }

            public string Title { get; set; }

            public EntityCollection<Track> Tracks { get; set; }
        }
    }

}