﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using RIAServicesWithPoco.Web.Models;
using System.Collections.ObjectModel;
using System.ServiceModel.DomainServices.Client;

namespace RIAServicesWithPoco.ViewModels
{
    public class MainPageViewModel : ViewModelBase
    {
        public MainPageViewModel()
        {
            Albums = new ObservableCollection<Album>();

            CurrentContext.Load(
                CurrentContext.GetAlbumsQuery(),
                LoadBehavior.MergeIntoCurrent,
                (loadOp) =>
                {
                    if (!loadOp.HasError)
                    {
                        foreach (Album album in loadOp.Entities)
                        {
                            Albums.Add(album);
                        }
                    }
                },
                null);

            CurrentContext.Load(
                CurrentContext.GetAlbumDataQuery(),
                LoadBehavior.MergeIntoCurrent,
                (loadOp) =>
                {
                    if (!loadOp.HasError)
                    {
                        foreach (AlbumData data in loadOp.Entities)
                        {
                            if (data.Album != null)
                            {
                                data.Album.Data = data;
                            }
                        }
                    }
                },
                null);
        }

        public ObservableCollection<Album> Albums { get; set; }
    }
}
